#!/bin/bash

if test "$1" = ""; then
   echo "Syntax = $0 <selection>"
   echo "Selection = \"full\" or \"busy_1\""
   exit 1
fi

if test "$1" != "full" && test "$1" != "busy_1" ; then
   echo "Ahem! Sorry, but I don't understand what you want to do."
   echo "Syntax = $0 <selection>"
   echo "Selection = \"full\" or \"busy_1\""
   exit 1
fi

export PATH=$PATH:/opt/hardhat/previewkit/mips/mipsel-linux-uclibc/bin:/opt/hardhat/previewkit/mips/fp_le/bin
CROSS_COMPILE=mipsel-uclibc
AS=$CROSS_COMPILE-as
LD=$CROSS_COMPILE-ld
RANLIB=$CROSS_COMPILE-ranlib
CPP="$CROSS_COMPILE-gcc -E"
AR=$CROSS_COMPILE-ar
NM=$CROSS_COMPILE-nm
STRIP=$CROSS_COMPILE-strip
OBJCOPY=$CROSS_COMPILE-objcopy
OBJDUMP=$CROSS_COMPILE-objdump
CFLAGS="-Os -s -ffunction-sections -fdata-sections"
LDFLAGS="-Wl,--gc-sections"
HOSTCC=/usr/bin/gcc
export AS LD CC CPP AR NM STRIP OBJCOPY OBJDUMP CFLAGS RANLIB LDFLAGS
make clean

if test "$1" = "full"; then
   cp dot-config-full-firmware .config
else
   cp dot-config-small-busy_1 .config
fi

make menuconfig
make CC=$CROSS_COMPILE-gcc HOSTCC=/usr/bin/gcc STRIP=$CROSS_COMPILE-strip
make CC=$CROSS_COMPILE-gcc HOSTCC=/usr/bin/gcc STRIP=$CROSS_COMPILE-strip install
