/* inflate.c -- LZMA kernel decompressor by Igor Mokrushin aka McMCC 2004,2005
 * For D-Link DSL-xxxT devices based on TI AR7 MIPS CPU
 */

#include <linux/config.h>
#include "LzmaDecode.c"

typedef unsigned char  uch;
typedef unsigned int   uin;
int tikernelunzip(int, char *[], char *[]);
static int tidecompress(uch *, uch *);
void kernel_entry(int, char *[], char *[]);
void (*ke)(int, char *[], char *[]); /* Gen reference to kernel function */
void (*prnt)(uin, char *);           /* Gen reference to Yamon print function */

void printf(char *ptr)
{
    uin *tempptr = (uin *)0x90000534; 
    prnt = ( void (*)(uin, char *)) *tempptr;
    (*prnt)(0, ptr);
}

int tikernelunzip(int argc, char *argv[], char *arge[])
{
    extern unsigned int _ftext;
    extern uch kernelimage[];
    int status;
    uch *indata, *outdata;

    printf("Copyright (C) 2006,2007 Merlion-ACORP Russia Software Company.\n");
    printf("Launching kernel LZMA decompressor.\n");
  
    outdata = (uch *)&_ftext;
    indata = &(kernelimage[0]);

    status = tidecompress(indata, outdata);

    if (status == 0)
    {
	printf("Kernel decompressor was successful ... launching kernel.\n");
        ke = (void(*)(int, char *[], char*[]))kernel_entry;
        (*ke)(argc, argv, arge);
        return (0);
    }
    else
    {
	printf("Error in decompression!\n");
        return(1);      
    }
}

static int tidecompress(uch *indata, uch *outdata)
{
    extern uin inflate_slide_window;
    extern uch kernelimage[];
    extern uch kernelimage_end[];
    uin in_size, out_size;
    uin window_size, osize_proc, ii;
    uch *window;
    uch properties[5], prop0;
    int lc, lp, pb;
    int res;

    window_size = 0;
    osize_proc = 0;
    out_size = 0;
    in_size = kernelimage_end - kernelimage;
    window  = (uch *)&inflate_slide_window;

    for(ii = 0; ii < 4; ii++)
    {
        properties[ii] = indata[ii];
        out_size += indata[5+ii] << (ii * 8);
    }

    prop0 = properties[0];
    if (prop0 >= (9*5*5))
    {
        printf("\nLZMA: Properties error!\n");
        return 1;
    }
    for (pb = 0; prop0 >= (9 * 5);
        pb++, prop0 -= (9 * 5));
    for (lp = 0; prop0 >= 9;
        lp++, prop0 -= 9);
    lc = prop0;

    window_size =
	(LZMA_BASE_SIZE + (LZMA_LIT_SIZE << (lc + lp))) * sizeof(CProb);

    res = LzmaDecode(window, window_size, lc, lp, pb,
		     indata+13, in_size-13,
		     outdata, out_size, &osize_proc);
    if (res == 1)
    {
        printf("\nLZMA: Uncompressed data error!\n");
        return 1;
    }
    if (res == 2)
    {
        printf("\nLZMA: Not enough memory!\n");
        return 1;
    }
    return 0;	
}
