/*   Replace utility
     Author: hai@ti.com
     
     This utility is used by PSPBoot header generation process.
     It replaces all instances of '@' or a given character with a CR.
*/
   
#include <stdlib.h>
#include <stdio.h>

int main( int argc, char *argv[] )
{
	FILE *in, *out;
	char buf[ 1 ];
	char replace = '@';
	char replaced = 0;
	
	if( argc < 2 || argc > 4 )
	{
		perror( "usage: replace <input filename> <output filename> [char-to-replace]" );
		return -1;
	}

	if( ( in = fopen( argv[ 1 ], "rb" ) ) == NULL )
	{
		perror( "Can't open input file" );
		return -1;
	}

	if( ( out = fopen( argv[ 2 ], "wb" ) ) == NULL )
	{
		perror( "Can't open output file" );
		fclose( in );
		return -1;
	}

	if( argc == 4 )
		replace = argv[3][0];

	while( fread( buf, sizeof( char ), 1, in ) == 1 )
	{
		if( ( replaced ) && ( *buf == ' ' ) )
		{
			replaced = 0;
			continue;
		}

		if( ( *buf == replace ) && ( !replaced ) )
		{
			*buf = '\n';
			replaced = 1;
		}
		else
			replaced = 0;

		if( fwrite( buf, sizeof( char ), 1, out ) != 1 )
		{
			perror( "Can't write to output file" );
			fclose( in );
			fclose( out );
			return -1;
		}
	}

	fclose( in );
	fclose( out );
	return 0;
}

