/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

/******************************************************************************
 * FILE NAME    :  usb20_state.h  
 *
 * DESCRIPTION  :  Implements USB20 Driver State Machine
 *
 * HISTORY 	:  
 *
 * 	Aug 05  -  sabyasachi  -  created. 
 *
 *****************************************************************************/


#ifndef __USB20_STATE_H
#define __USB20_STATE_H

#include "pal.h"
#include "usb20_lib.h"


/*****************************************************************************
 * 
 *                ===================================
 *                |  States for USB Protocol Driver | 
 *                ===================================
 *
 * These states are defined as per USB 2.0 Protocol Specification
 * 
 * State Name                     Description 
 * --------------------------------------------------------------------------

 ****************************************************************************/

typedef enum _USB20_STATE 
{
        USB20_DRV_STATE_DETACHED = 0,
        USB20_DRV_STATE_SUSPENDED,
        USB20_DRV_STATE_DEFAULT,
        USB20_DRV_STATE_ADDRESS,
        USB20_DRV_STATE_CONFIGURED
}USB20_STATE;


INT32 usb_drv_state_init(void);
INT32 usb_drv_set_state(UINT32 state);
INT32 usb_drv_get_state(void);
INT32 usb_drv_state_shutdown(void);


#endif  /* __USB20_STATE_H  */
