/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

/**************************************************************************
 * FILE PURPOSE :   Definitions for USB Admin Tool
 **************************************************************************
 * FILE NAME    :   usb20_tool.h
 *
 * DESCRIPTION  :
 *
 *************************************************************************/

#ifndef __USB20_USER_H_
#define __USB20_USER_H_

#include "usb20_config.h"

#define USB_TOOL_VERSION_MAJOR   0
#define USB_TOOL_VERSION_MINOR   1

typedef void (*USB_ADMIN_FUNC)(char **, int );
typedef void (*USB_ADMIN_HELP_FUNC)();

typedef struct _USB_ADMIN_CMD
{
     char  *name;                           /* command name */
     USB_ADMIN_FUNC   action;        /* command action routine */
     USB_ADMIN_HELP_FUNC help_action;
     char  *help_str;
} USB_ADMIN_CMD;



#endif  /* __USB20_USER_H_ */


