/*******************************************************************************
**+--------------------------------------------------------------------------+**
**|                            ****                                          |**
**|                            ****                                          |**
**|                            ******o***                                    |**
**|                      ********_///_****                                   |**
**|                      ***** /_//_/ ****                                   |**
**|                       ** ** (__/ ****                                    |**
**|                           *********                                      |**
**|                            ****                                          |**
**|                            ***                                           |**
**|                                                                          |**
**|         Copyright (c) 1998-2005 Texas Instruments Incorporated           |**
**|                        ALL RIGHTS RESERVED                               |**
**|                                                                          |**
**+--------------------------------------------------------------------------+**
*******************************************************************************/

#ifndef _TITAN_CLK_CNTL_H_
#define _TITAN_CLK_CNTL_H_

/*****************************************************************************
 * Clock Control 
 *****************************************************************************/

#define CLK_MHZ(x)    ( (x) * 1000000 )

/* The order of ENUMs here should not be altered since
 * the register addresses are derived from the order
 */

typedef enum PAL_SYS_CLKC_ID_tag
{
    CLKC_VBUS = 0,  /* Clock driving VBUS */
    CLKC_MIPS,      /* Clock to MIPS */
    CLKC_USB,       /* Clock to USB slave */
    CLKC_LCD,       /* Clock to LCD controller */
    CLKC_VBUSP,      /* Clock to VBUSP */
    CLKC_SYS        /* Clock to SYS */
} PAL_SYS_CLKC_ID_T;

/**
 * This stucture is populated and passed on to the pal_sys_clkc_init function
 */
typedef struct PAL_SYS_Tnetv1050Init_tag
{
    UINT32 audclk;
    UINT32 refclk;
    UINT32 altclk;
    
} PAL_SYS_Tnetv1050Init;

#endif
