//-------------------------------------------------------------------------------------
// Copyright 2005, Texas Instruments Incorporated
//
// This program has been modified from its original operation by Texas Instruments
// to do the following:
// 
// 1. NSP Policy Routing Framework
//
// THIS MODIFIED SOFTWARE AND DOCUMENTATION ARE PROVIDED
// "AS IS," AND TEXAS INSTRUMENTS MAKES NO REPRESENTATIONS 
// OR WARRENTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
// TO, WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY 
// PARTICULAR PURPOSE OR THAT THE USE OF THE SOFTWARE OR 
// DOCUMENTATION WILL NOT INFRINGE ANY THIRD PARTY PATENTS, 
// COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS. 
// See The GNU General Public License for more details.
//
// These changes are covered under version 2 of the GNU General Public License, 
// dated June 1991.
//-------------------------------------------------------------------------------------

#ifndef _PR_MARK_H
#define _PR_MARK_H

/* NSP Policy Routing Framework: Adding an option which allows to pass a mark value for a particular
 * socket. */
#define POLICY_ROUTING_MARK     17

#define UPDATEDD_PR_MARK        0xE1
#define DPROXY_PR_MARK          0xE2
#define MINIHTTPD_PR_MARK       0xE3
#define MSNTP_PR_MARK           0xE4
#define UDHCP_PR_MARK           0xE5
#define IPTABLES_PR_MARK        0xE6
#define PPPD_PR_MARK            0xE7
#define IPROUTE_PR_MARK         0xE8
#define LIBATM_PR_MARK          0xE9
#define NETTOOLS_PR_MARK        0xEA
#define ROUTED_PR_MARK          0xEB
#define ROUTEDV2_PR_MARK        0xEC
#define OPENSSL_PR_MARK         0xED
#define UPNP_PR_MARK            0xEE
#define BUSYBOX_PR_MARK         0xEF
#define CFGMGR_PR_MARK          0xF0
#define DROPBEAR_PR_MARK        0xF1

#endif	/* _PR_MARK_H */
