/* -- updatedd: noip.h --
 *
 * Copyright (C) 2002, 2003, 2004 Philipp Benner
 *
 * This file is part of UpdateDD - http://updatedd.philipp-benner.de.
 *
 * UpdateDD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * UpdateDD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with UpdateDD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <ret_codes.h>

#define DYNDNSHOST	"dynupdate.no-ip.com"
#define PORT		80

#define BUFSIZE		512

#define ARGV_PNAME	0
#define ARGV_LOGIN	argc-2
#define ARGV_HOSTNAME	argc-1

#define COLORED(x)	"\033[0;35;1m"x"\033[0m"

static char ret_msg_buf[BUFSIZE];

struct arguments {
	char *hostname;
	const char *group;
	char *ipv4;
	char *login;
        const char *iface;
        const char *force;
};

static struct dyndns_return_codes {
	const int code;
	const char *message;
	const int  error;
} return_codes[] = {
	{ 0,	"No update needed.nochg",				0 },
	{ 1,	"Update good and successful, IP updated.good",				0 },
	{ 2,	"Bad hostname.error",					1 },
	{ 3,	"Bad password.error",					1 },
	{ 4,	"Bad user.error",					1 },
	{ 6,	"Account has been banned.error",			1 },
	{ 7,	"Invalid ip.error",					1 },
	{ 8,	"Host has been disabled.error",			1 },
	{ 9,	"Invalid host (web redirect).error",			1 },
	{ 10,	"Bad group.error",					1 },
	{ 11,	"Group has been updated.good",			0 },
	{ 12,	"No update needed.nochg",				0 },
	{ 13,	"This client software has been disabled.error",	1 },
	{ 0,	NULL,						0 }
};

static int get_flags(struct arguments *args, int argc, char *argv[]);
static int update_dyndns(int s, struct arguments *args);
static int check_server_msg(int s, char *hostname);

inline void
stolower(char *str, char *buf, size_t size)
{

	int n;

	for(n = 0; n < size && str[n] != '\0'; n++) {
		buf[n] = tolower(str[n]);
	}
	buf[n] = '\0';

	return;

}

char *
get_retmsg(void)
{
	return ret_msg_buf;
}
