/***************************************************************************\
*****************************************************************************
**                                                                         **
** source file:    error.c                                                 **
** last revision:  23/02/2004                                              **
**                                                                         **
*****************************************************************************
*****************************************************************************
**                                                                         **
** This program is free software; you can redistribute it and/or modify it **
** under the terms of the GNU General Public License as published by the   **
** Free Software Foundation; either version 2, or (at your option) any     **
** later version.                                                          **
**                                                                         **
** This program is distributed in the hope that it will be useful,         **
** but WITHOUT ANY WARRANTY; without even the implied warranty of          **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           **
** GNU General Public License for more details.                            **
**                                                                         **
** You should have received a copy of the GNU General Public License       **
** along with this program; if not, write to the Free Software             **
** Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.                     **
**                                                                         **
*****************************************************************************
\***************************************************************************/

//---------------------------------------------------------------------------------------
//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
//---------------------------------------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "common.h"
#include "error.h"

//---------------------------------------------------------------------------------------
//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
//---------------------------------------------------------------------------------------
// This Prints A Warning

void warning(char *prod, char *message)
{
  if (message == NULL)
    return;

  if (prod != NULL)
    fprintf(stderr, "\n%s: warning in %s(): %s.\n\n", PROGRAM_NAME, prod, message);
  else
    fprintf(stderr, "\n%s: warning: %s.\n\n", PROGRAM_NAME, message);

  return;
}


//---------------------------------------------------------------------------------------
//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
//---------------------------------------------------------------------------------------
// This Prints An Error Message

void error(char *prod, char *message, int error_id)
{
  if (message == NULL)
    {
      if (prod != NULL)
        fprintf(stderr, "\n%s: error in %s(): %s.\n\n", PROGRAM_NAME, prod, strerror(error_id));
      else
        fprintf(stderr, "\n%s: error: %s.\n\n", PROGRAM_NAME, strerror(error_id));
    }
  else
    {
      if (prod != NULL)
        fprintf(stderr, "\n%s: error in %s(): %s.\n\n", PROGRAM_NAME, prod, message);
      else
        fprintf(stderr, "\n%s: error: %s.\n\n", PROGRAM_NAME, message);
    }

  return;
}


//---------------------------------------------------------------------------------------
//|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
//---------------------------------------------------------------------------------------
